"use strict";
var SCREEN_W = 1024,
    SCREEN_H = 576;

var SCALE = 1;
var SCW = SCREEN_W/SCALE;
var SCH = SCREEN_H/SCALE;

var DEBUG = true;
var print = console.log;

var game = new Magic( SCREEN_W, // canvas width
		      SCREEN_H, // canvas height
		      'game', // canvas element
		      'game'  // state to boot into
		    );

var mouse = new Mouse( game.canvas );
var keys = new Keyboard();
var showtitle = true;
// Resources

game.preload = function() {
    this.load.image("girl", "img/girl.png");
    this.load.image("girlhappy", "img/girlhappy.png");
    this.load.image("girlsurp", "img/girlsurp.png");
    this.load.image("girldis", "img/girldis.png");
    this.load.image("girlemb", "img/girlemb.png");
    this.load.image("girlangry", "img/girlangry.png");
    this.load.image("girlblush", "img/girlblush.png");
    this.load.image("girlscared", "img/girlscared.png");
    this.load.image("girlsmile", "img/girlsmile.png");
    this.load.image("bubbleyou", "img/bubbleyou.png");
    this.load.image("bubbleher", "img/bubbleher.png");
    this.load.image("ghostbubble", "img/ghostbubble.png");
    this.load.image("lost", "img/girldis.png");
    this.load.image("won", "img/won.png");
    this.load.image("halo", "img/halo.png");
    this.load.image("bg", "img/bg.png");
    this.load.image("title", "img/title.png");

    this.load.sound("get", "snd/get.ogg", "snd/get.m4a");
    this.load.sound("drop", "snd/drop.ogg", "snd/drop.m4a");
    this.load.sound("sad", "snd/sad.ogg", "snd/sad.m4a");
    this.load.sound("happy", "snd/happy.ogg", "snd/happy.m4a");
    this.load.sound("love", "snd/love.ogg", "snd/love.m4a");
};

game.state['game'].create = function() {
    //fontbold.table = getFontTable( this.image.fontbold, "abcdefghijklmnopqrstuvwxyz.,!?", fontbold.ftw, fontbold.fth);
    game.context.font = "25px arial";
    game.sound.sad.loop = true;
    game.sound.happy.loop = true;
    game.sound.love.loop = true;
};

var timer = Date.now();
game.state['game'].update = function()
{
    mouse.update();

    // if( Date.now() - timer > 3000 ) {
    // 	var s = rand(0, 4);
    // 	thinking.fart[s].x = rand(100, SCW-100);
    // 	thinking.fart[s].y = rand(50, 300) ;
    // 	thinking.fart[s].update();
    // 	thoughts.push(thinking.fart[s]);
	
    // 	timer = Date.now();
    // }
    dialoguestate[dialoguestate.state]();
    thoughtstate[thoughtstate.state]();
    bubblestate[bubblestate.state]();
    winstate[winstate.state]();
    
    keys.clear();
};

game.state['game'].render = function( context )
{
    context.save();
    context.scale(SCALE, SCALE);
    context.clearRect(0, 0, SCW, SCH);
    context.fillStyle = "#ffe9e8";
    context.fillRect(0, 0, SCW, SCH);
    context.drawImage(this.image.bg, SCW/2 - this.image.bg.width/2,20);
    girl.render(context,this.image);
    ghostbubble.render(context, this.image);
    herbubble.render(context, this.image);
    herphrase.render(context);
    playerbubble.render(context, this.image);
    playerphrase.render(context);
    //context.drawImage(this.image.bubbleher, SCW/2 - this.image.bubbleher.width/2, 300);
    //context.drawImage(this.image.bubbleyou, SCW/2 - this.image.bubbleher.width/2, 335);
    if( showtitle ) {
	context.drawImage(this.image.title, SCW/2 - this.image.title.width/2, 0);
    }

    for( var i=0; i<thoughts.length; i++ ) {
	thoughts[i].render( context, this.image );
    }
    // renderSpriteRect(bubble,context);
    // renderSpriteRect(thoughts[0],context);
    winstate.render(context, this.image);
    context.restore();
};

game.state['game'].reset = function() {};

game.canvas.focus();
game.start();

//------------------------------
// Game functions

function rand( min, max ) {
    return (Math.random()*(max-min)|0) + min;
}

function newObject( base ) {
    return function( newprops ) {
	var newobj = {};
	for( var k in base ) newobj[k] = base[k];
	for( k in newprops ) newobj[k] = newprops[k];
	return newobj;
    };
}

var newSprite = newObject({img: "default", x: 0, y:0, z:0, update: emptyF, render: renderBasic});

function emptyF(){};

function renderBasic( context ) { context.drawImage( this.img, this.x, this.y ); }

function renderColor( context ) {
    context.fillStyle = this.color;
    context.fillRect( this.x, this.y, this.w, this.h );
}

function block( val, min, max ) {
    if( val < min ) return min;
    else if( val > max ) return max;
    else return val;
}

function renderText( context ) {
    context.save();
    context.fillStyle = "#000";
    context.textAlign = "center";
    context.globalAlpha = this.alpha * 0.8;
    fillTextWrap( context, this.text, this.x, this.y, this.w, 25 );
    context.restore();
}

function renderThought( context, images ) {
    context.globalAlpha = this.alpha;
    context.drawImage(images.halo, this.x + this.w/2 - images.halo.width/2, this.y + this.h/2- images.halo.height/2);
    
    context.save();
    context.fillStyle = "#000";
    context.textAlign = "center";
    context.globalAlpha = 0.7*this.alpha;
    context.fillText(this.text, this.x + this.w/2 + this.shake*Math.random(), this.y + this.h/2 + 10 + this.shake * Math.random());
    //var nlines = fillTextWrap( context, this.text, this.x, this.y, 200, 25 );
    context.restore();

    // context.save();
    // context.globalAlpha = 0.5;
    // var scaley = nlines;
    // context.scale(1,scaley);
    // context.drawImage(images.par, this.x - images.par.width, (this.y - images.par.height/2-5)/scaley);
    // context.drawImage(images.parc, this.x + this.w, (this.y - images.par.height/2-5)/scaley);
    // context.restore();
}

var bubble = {w: 200, h: 60, x: SCW/2 - 100, y: 400 };
var home = {x: SCW/2, y: 415};

function updateDelta() {
    this.dx = (home.x - this.x - this.w/2)/this.speed;
    this.dy = (home.y - this.y - this.h/2)/this.speed;
}

var newThought = newObject({text:"prova", x: 0, y:0, render: renderThought, homing: false, speed: 180, w: 100, h: 100, alpha: 1, update: updateDelta, dialogue: "begin", shake: 0});

var thoughts = [];

var thoughtstate = {
    state: "bounce",
    none: emptyF,
    updateThought: function( t ) {
	if( t.homing && ghostbubble.alpha != 0) {
	    t.x += t.dx;
	    t.y += t.dy;
	}
    },
    changeToFade: function(i, t) {
	game.sound.drop.currentTime = 0;
	game.sound.drop.play();
	this.state = "fadehomed";
	this.frames = 20;
	this.movex = (-t.x-t.w/2 + home.x)/this.frames;
	this.movey = (-t.y-t.h/2 + home.y)/this.frames;
	this.homed = i;
    },
    bounce: function() {
	for( var i=0; i<thoughts.length; i++ ) {
	    var t = thoughts[i];
	    this.updateThought(t);
	    if( ghostbubble.alpha != 0 && isInside({x: t.x+t.w/2, y:t.y + t.h/2}, bubble ) ) {
		this.changeToFade(i, t);
	    } else if( mouse.isClicked.left && isInside(mouse, t) ) {
		game.sound.get.currentTime = 0;
		game.sound.get.play();

		this.grabbed = i;
		this.state = "grabbing";
		this.dx = mouse.x - thoughts[i].x;
		this.dy = mouse.y - thoughts[i].y;
	    }
	}
    },
    grabbing: function() {
	if(thoughts[this.grabbed]) {
	    thoughts[this.grabbed].x = mouse.x - this.dx;
	    thoughts[this.grabbed].y = mouse.y - this.dy;
	    if( !mouse.isDown.left ) {
		this.state = "bounce";
		thoughts[this.grabbed].update();
		this.grabbed = -1;
	    }
	    
	    for( var i=0; i<thoughts.length; i++ ) {
		var t = thoughts[i];	    
		if( i != this.grabbed ) this.updateThought(thoughts[i]);
		if( ghostbubble.alpha != 0 && isInside({x: t.x+t.w/2, y:t.y + t.h/2}, bubble ) ) {
		    this.changeToFade(i, t);
		}
	    }
	} else {
	    this.state = "bounce";
	    this.grabbed = -1;
	}
    },
    fade: function() {
	thoughts[this.homed].x += this.movex;
	thoughts[this.homed].y += this.movey;
	for( var i=0; i<thoughts.length; i++ ) {
	    var t = thoughts[i];
	    if( i != this.homed ) {
		t.alpha -= 1/this.frames;
		if( t.alpha < 0 ) {
		    t.alpha = 0;
		    this.state = "fadehomed";
		}
	    }
	}
    },
    fadehomed: function() {
	ghostbubble.alpha -= 0.05;
	thoughts[this.homed].alpha -= 0.05;
	if( ghostbubble.alpha <= 0) {
	    ghostbubble.alpha = 0;
	    thoughts[this.homed].alpha = 0;
	    this.state = "bounce";
	    dialoguestate.state = "play";
	    dialoguestate.dialogue = thoughts[this.homed].dialogue;
	    thoughts.splice(this.homed, 1);
	}
    },
    movex: 0,
    movey: 0,
    frames: 20,
    homed: -1,
    dx: 0,
    dy:0,
    grabbed: -1
};

var bubblestate = {
    state: "create",
    none: emptyF,
    create: function() {
	var increment = 0.1;
	var dy = 2;
	if( herphrase.text != "" ) {
	    herbubble.alpha += increment;
	    herphrase.alpha += increment;
	    herbubble.y += dy;
	    herphrase.y += dy;
	    if(herbubble.y > 270) {
		herbubble.y = 270;
		herphrase.y = 345;
		herbubble.alpha = 1;
		herphrase.alpha = 1;
		this.lastdate = Date.now();
		this.state = "wait";
	    }
	}
	if( playerphrase.text != "" ) {
	    playerbubble.alpha += increment;
	    playerphrase.alpha += increment;
	    playerbubble.y -= dy;
	    playerphrase.y -= dy;
	    if(playerbubble.y < 370) {
		playerbubble.y = 370;
		playerphrase.y = 430;
		playerbubble.alpha = 1;
		playerphrase.alpha = 1;
		this.lastdate = Date.now();
		this.state = "wait";
	    }
	}	    
    },
    fade: function() {
	var increment = 0.1;
	herbubble.alpha -= increment;
	herphrase.alpha -= increment;
	playerbubble.alpha -= increment;
	playerphrase.alpha -= increment;
	if( herbubble.alpha <= 0 || playerbubble.alpha <= 0 ) {
	    herbubble.alpha = 0;
	    herphrase.alpha = 0;
	    playerbubble.alpha = 0;
	    playerphrase.alpha = 0;
	    herbubble.y = 240;
	    herphrase.y = 315;
	    playerbubble.y = 400;
	    playerphrase.y = 460;
	    playerphrase.text = "";
	    herphrase.text = "";
	    this.state = "create";
	    dialoguestate.increase();
	}
    },
    wait: function() {
	if( Date.now() - this.lastdate > this.waittime || mouse.isClicked.right ) {
	    this.state = "fade";
	}
    },
    lastdate: 0,
    waittime: 3500
};

var dialoguestate = {
    state: "play",
    none: emptyF,
    play: function () {
	var line = dialogues[this.dialogue][this.dialogueindex];
	if( line.her === undefined || line.her == "" ) {
	    herphrase.text = "";
	} else {
	    herphrase.text = line.her;
	}
	if( line.you === undefined || line.you == "" ) {
	    playerphrase.text = "";
	} else {
	    playerphrase.text = line.you;
	}
	
	if( line.img != undefined ) girl.img = line.img;

	if( line.wait ) {
	    this.state = "wait";
	    this.timewait = line.wait;
	    this.datewait = Date.now();
	}
	if( line.thoughts ) {
	    for( var i=0; i < thinking[line.thoughts].length; i++ ) {
		thoughts.push(thinking[line.thoughts][i]);
	    }
	 
	    this.increase();
	}
	if( line.won ) {
	    thoughtstate.state = "none";
	    winstate.state = "won";
	    this.state = "none";
	}
	if( line.lost ) {
	    thoughtstate.state = "none";
	    winstate.state = "lost";
	    this.state = "none";
	}
	if( line.func ) line.func();
    },
    increase: function() {
	//if( keys.isPressed.space || mouse.isClicked.right ) {
	this.dialogueindex++;
	if( this.dialogueindex >= dialogues[this.dialogue].length ) {
	    this.dialogueindex = 0;
	    ghostbubble.alpha = 0.7;
	    this.state = "none";
	}	
	//}
    },
    wait: function() {
	if( Date.now() - this.datewait > this.timewait ) {
	    this.dialogueindex++;
	    this.state = "play";
	}
    },
    datewait: 0,
    timewait: 500,
    dialogueindex: 0,
    dialogue: "begin"
};

function renderBubble( context, images ) {
    context.save();
    context.globalAlpha = this.alpha;
    context.translate(this.x, this.y);
    context.scale(1.3, this.scale);
    context.drawImage( images[this.img], -images[this.img].width/2, 0 );
    context.restore();
}

function renderGirl( context, images) {
    context.save();
    context.drawImage( images[this.img], this.x - images[this.img].width/2, this.y );
    context.restore();
}

var herbubble = newSprite({img: "bubbleher", x: SCW/2, y: 240, render: renderBubble, alpha: 0, scale: 0.6});
var playerbubble = newSprite({img: "bubbleyou", x: SCW/2, y: 400, render: renderBubble, alpha: 0, scale:0.7});
var ghostbubble = newSprite({img: "bubbleyou", x: SCW/2, y: 370, render: renderBubble, alpha: 0, scale:0.7});
var girl = newSprite({img: "girl", x: SCW/2, y: 20, render: renderGirl});

var playerphrase = newSprite({render: renderText, x: SCW/2, y: 460, w: 500, text: "", alpha: 0});
var herphrase = newSprite({render: renderText, x: SCW/2, y: 315, w: 500, text: "", alpha: 0});

function isInside( p, obj ) {
    var px = p.x,
	py = p.y;
    var x = obj.x,
	y = obj.y,
	w = obj.w,
	h = obj.h;
    if( px > x  && px <= x + w &&
	py > y && py <= y + h )
    {
	return true;
    } else {
	return false;
    }
}

function doIntersecate( s1, s2 ) {
    if( s1.x <=s2.x + s2.w &&
	s1.x + s1.w >=  s2.x &&
	s1.y <= s2.y + s2.h &&
	s1.y + s1.h >= s2.y )
    {
	return true;
    } else {
	return false;
    }
}

function renderSpriteRect( s, context ) {
    context.strokeStyle = "#000";
    context.strokeRect(s.x, s.y, s.w, s.h);
}

var winstate = {
    state: "none",
    none: emptyF,
    bgalpha: 0,
    textalpha: 0,
    inc: 0.01,
    text: "",
    img: "girl",
    render: function(context, images) {
	context.save();
	context.globalAlpha = this.bgalpha;
	context.fillStyle = "#fdedf8";
	context.fillRect(0, 0, SCW, SCH);
	context.drawImage(images[this.img], SCW/2 - images[this.img].width/2, 20);
	context.globalAlpha = this.textalpha;
	context.fillStyle = "#555";
	context.textAlign = "center";
	context.fillText(this.text, SCW/2+300, 300);
	context.restore();
    },
    won: function() {
	this.text = "You found love";
	this.img = "won";
	this.bgalpha += this.inc;
	if( this.bgalpha > 1 ) {
	    this.bgalpha = 1;
	    this.state = "wait";
	    this.datewait = Date.now();
	}
    },
    wontext: function() {
	this.textalpha += this.inc;
    },
    lost: function() {
	this.text = "You lost her forever";
	this.img = "lost";
	this.bgalpha += this.inc;
	if( this.bgalpha > 1 ) {
	    this.bgalpha = 1;
	    this.state = "wait";
	    this.datewait = Date.now();
	}
    },
    wait: function() {
	if( Date.now() - this.datewait > this.timewait ) {
	    this.dialogueindex++;
	    this.state = "wontext";
	}
    },
    datewait: 0,
    timewait: 1000
};

///////////////////////////

var thinking = {
    fart: [
	newThought({text: "Err", dialogue: "temp1", homing: true}),	
	newThought({text: "Uhm", dialogue: "temp2", homing: true}),	
	newThought({text: "You know", dialogue: "temp3", homing: true}),	
	newThought({text: "Um", dialogue: "temp4", homing: true})	
    ],

    
    begin: [
	newThought({x: 100, y:40, text: "Start Game", dialogue: "start"}),
    ],
    start: [
	newThought({x: 100, y:40, text: "Traffic", dialogue: "traffic"}),
	newThought({x: 300, y:80, text: "Nervous", dialogue: "nervous", shake: 2}),
    ],
    thankgod: [
	newThought({text: "Thank fucking God", dialogue: "thankgod"}),
    ],
    loveyou: [
	newThought({text: "Because I love you", dialogue: "loveyou", shake:2, homing:true})
    ],
    whynervous: [
	newThought({x: 300, y:80, text: "Sorry", dialogue: "sorry"}),
	newThought({text: "I practiced for two hours to tell you I love you", dialogue: "practice"}),
    ],
    wedo: [newThought({text: "We do make a good couple", dialogue: "wedo"}),
	newThought({x: 100, y:40, text: "You are stunning", shake:2, homing: true, dialogue: "beautiful"}),
	newThought({text: "Boyfriend", dialogue: "boyfriend"})
	  ],
    happy: [
	newThought({x: 100, y:40, text: "You are so beautiful", shake:2, homing: true, dialogue: "beautiful"}),
	newThought({x: 100, y:40, text: "I'm happy too", dialogue: "too"}),
    ],
    what: [
	newThought({text: "You are my ideal woman", dialogue: "ideal", shake: 2, homing:true}),
    ],
    seeyou: [
	newThought({x: 100, y:40, text: "I always liked to see you", dialogue: "seeyou"}),
	newThought({text: "Your breasts are amazing", dialogue: "tits", shake:2, homing: true}),
    ],
    beautiful: [
	newThought({x: 100, y:40, text: "You were so beautiful it hurt", dialogue: "beautiful", homing:true, shaking:2}),
    ],

    
    fuckedup1: [newThought({x: 100, y:40, text: "This can't be happening", dialogue: "too"}),],
    fuckedup2: [newThought({x: 100, y:40, text: "I am a fucking idiot", dialogue: "beautiful"}),],
    fuckedup3: [newThought({x: 100, y:40, text: "Fuuuck!", dialogue: "beautiful"}),],
    fuckedup4: [
	newThought({x: 100, y:40, text: "Why won't I shut up", dialogue: "beautiful"}),
	newThought({x: 100, y:40, text: "You are my life", dialogue: "beautiful"}),
    ],
    fuckedup5: [
	newThought({x: 100, y:40, text: "No, please, no!", dialogue: "beautiful"}),
	newThought({x: 100, y:40, text: "I love you, Helen", dialogue: "beautiful"}),
    ],
    fuckedup6: [
	newThought({x: 100, y:40, text: "I can't live without you"}),
	newThought({x: 100, y:40, text: "I hate myself"}),
	newThought({x: 100, y:40, text: "Life has no meaning without you"}),
	newThought({x: 100, y:40, text: "Nooooooooooo!"}),
    ],
    kiss: [
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
	newThought({x: 100, y:40, text: "I want to kiss you", shake: 2, dialogue: "kiss"}),
    ]
};

for( var k in thinking ) {
    var bl = thinking[k];
    for( var i=0; i<bl.length; i++ ) {
	bl[i].x = rand(100, SCW-100);
	bl[i].y = rand(50, 300);
	bl[i].update();
    }
}

var mistakes = 0;
function mist() {
    mistakes++;
    if( mistakes >= 3 ) {
	dialoguestate.dialogue = "lose";
	dialoguestate.dialogueindex = 0;
    } else {
	dialoguestate.increase();
    }
}
var nervous = 0;

var dialogues = {
    ideal: [

	{you: "You are my ideal woman"},{func:mist},
	{her: "...", img:"girlemb"},
	{her: "Jack, what is happening to you?"},
	{you: "Um, well"},
	{you: "It is not a lie"},
	{her: "I, um... Ok?"},
	{her: "It is just weird"},
	{her: "Please stop"},
	{you: "Sorry, I feel a little tired today"},
    ],
    practice: [
	{you: "I practiced for..."},
	{you: "...", img: "girlsurp"},
	{you: "Nevermind"},
	{her: "What?"},
	{you: "Nothing"},
	{you: "Just something stupid"},
	{her: "You seem a little distracted", img:"girlhappy"},
	{wait:1000},
	{her: "I'm happy to see that"},
	{her: "It means you haven't changed"},
	{her: "I like that about you", img: "girlblush"},
    ],
    temp1: [
	{you: "Err..."},
    ],
    temp2: [
	{you: "Um..."},
    ],
    temp3: [
	{you: "You know..."},
    ],
    temp4: [
	{you: "Uuh..."},
    ],
    begin:[
	{thoughts:"begin"}
    ],
    start: [
	{her: "Hey Jack!",func:function(){game.sound.happy.play(); showtitle=false;} },
	{her: "Here you are, finally!"},
	{you: "Helen! Sorry for the delay"},
	{her: "I was starting to get worried"},
	{her: "Usually you are always on time"},
	{her: "Something happened?"},
	{thoughts: "start"}
    ],
    boyfriend: [
	{you: "So, any news on the love front?"},
	{her: "Ahh, you know what they say", img:"girlblush"},
	{her: "Sometimes no news is good news"},
	{you: "So, still lonely?", thoughts: "thankgod"},
	{her: "I guess so"},
	{her: "...", you: "..."},
	{her: "well, and what about you?", img:"girl"},
	{her: "You are always so mysterious"},
	{her: "Still nothing?"},
	{you: "Not really" },
	{her: "Well, don't sweat it"},
	{you: "Heh, I guess you are right"},
	{her: "..."},
    ],
    thankgod: [
	{you: "Thank fucking God"},
	{her: "...What?", img: "girlsurp"},
	{you: "Oh, ehm"},
	{you: "Nothing"},
	{you: "Got a little... "},
	{you: "Caught in my mind"},
	{her: "...", img:"girl"},
    ],
    traffic: [
	{you: "Got stuck in the traffic"},
	{you: "It is a jungle out there"},
	{her: "Traffic, uh?", img:"girl"},
	{her: "Don't tell me about it"},
	{her: "I had to rush to finish work in time"},
	{her: "And then I got blocked on the highway"},
	{her: "Twenty minutes", img:"girlangry"},
	{her: "*sigh*", you:"Wow"},
	{her: "Had a rough day"},
	{you: "Still keeping you late at the office?"},
	{her: "Yeah.",img:"girl"},
	{her: "Things are going a little better luckily."},
	{you: "...", her:"..."},
	{her: "So, why did you want to see me?",img:"girl"},
	{her: "Did you want to tell me something?"},
	{her: "Sounded like it from your call"},
	{you: "Me? Uh..."},
	{thoughts: "what"}
    ],
    nervous: [
	{you: "I'm a little nervous"},
	{her: "Nervous?", img:"girlsurp"},
	{her: "Why would you be?"},
	{her: "We know each other since we were kids!", img:"girlhappy"},{thoughts: "loveyou"},
	{her: "Why would you be nervous?", img:"girl"},
	{her: "We are almost a family, aren't we?", img:"girl"},
	{you: "I guess so", img:"girl"},
	{you: "You are a great girl, you know?"},
	{her: "Hey, there"},
	{her: "I have my fair share of problems"},
	{her: "Just like everyone else"},
	{thoughts: "whynervous"}
    ],
    sorry: [
	{you: "I'm sorry about that"},
	{her: "Haha, don't even think about it", img: "girlhappy"},
	{her: "I'm just happy that you are here"},
	{thoughts: "happy"}
    ],
    beautiful: [
	{you: "You are so beautiful"},{ func: mist},
	{her: "...", you: "...", img:"girlemb"},
	{her: "Where did this come from?"},
	{you: "I am so sorry.",her: "You caught me off guard"},
	{you: "I don't know what came over me."},
    ],
    loveyou: [
	{you: "I love you"},{ func:mist},
	{her: "...", you:"...",img: "girlemb"},
	{her: "...", you:"As a friend",img: "girlemb"},
	{her: "...", you:"...",img: "girlemb"},
	{her: "Jack..."},
	{her: "Please do not say something like that"},
	{her: "We have always been friends"},
	{her: "You can't say that"},
	{her: "We have built a beautiful friendship"},
	{you: "I meant as a friend"},
	{her: "..."},
	{her: "Sure, yeah"},
    ],
    tits: [
	{you: "You have wonderful breasts"},{ func: mist},
	{her: "...", you: "...", img:"girlemb"},
	{her: "Jack, what the fuck?"},
	{you: "Fuck"},
	{you: "I'm so sorry."},
	{you: "Really, forget that...", her: "I don't know..."},
	{you: "...", her: "..."},
	{her: "I will try to ignore that"},
	{her: "You probably hit your head or something"},
    ],
    too: [

	{you: "I'm happy too"},
	{her: "Yeah! we make a great couple", img: "girlhappy"},
	{her: "Um... A great friend couple", img: "girlemb"},{ thoughts: "wedo"},
    ],
    wedo: [
	{you: "We would really make a great couple"},
	{her: "What?", img: "girlsurp"},
	{you: "We really do"},
	{you: "You are good at the money stuff and I..."},
	{you: "Well, I'm a good cook"},
	{her: "..."},
	{her: "You really are", img: "girlblush"},
	{her: "..."},
	{her: "I still remember the time you helped me"},
	{her: "Do you remember?"},
	{you: "When?"},
	{her: "When my dad was sick"},
	{her: "I was out all day"},
	{her: "And you brought dinner for me"},
	{her: "Every night", thoughts: "beautiful"},
	{you: "It was nothing"},{ thoughts: "seeyou"},
	{her: "No it wasn't", img: "girlangry"},
	{her: "You can't understand how grateful I am", img:"girl"},
	{her: "To... Well"},
	{you: "Have me?"},
	{her: "..."},
	{her: "Yeah"},
	{her: "Yeah.", img:"girlblush"},
	{her: "...", you:"..."}
    ],
    seeyou: [
	{you: "I am always happy to see you too"},
	{her: "...", img:"girlblush"},
	{wait:1000},
	{her: "Jack"},
	{her: "..."},
	{her: "This is something really hard to say..."},
	{you: "What?"},
	{her: "I..."},
	{her: "Ah, forget it"},
	{her: "It isn't really important"},
	{you: "Doesn't seem like it from your face"},
	{you: "..."},
	{her: "Jack.", img:"girldis", func:function(){game.sound.happy.pause();}},
	{you: "What?"},
	{her: "I don't know", img:"girldis"},
	{her: "I..."},
	{her: "I'm scared", img:"girlscared",func:function(){game.sound.love.play();}},
	{her: "It doesn't make any sense"},
	{you: "Helen..."},
	{her: "I really like you, Jack"},
	{her: "And I don't mean like a friend alone"},
	{her: "I really love you"},
	{her: "And I'm so scared"},
	{her: "I always thought I could find someone else"},
	{her: "That I could just..."},
	{her: "Forget about you"},
	{you: "It is alright"},
	{her: "No, it isn't"},
	{her: "I'm getting old, Jack"},
	{her: "I'm 33, and I'm alone"},
	{her: "All my girlfriend are already married"},
	{her: "Do you think I can live like this?"},
	{her: "Always lying to myself"},
	{her: "About my feelings"},
	{her: "..."},
	{her: "Towards you"},
	{her: "Jack"},
	{you: "Helen"},
	{her: "But I will ruin our friendship"},
	{her: "I can't do this"},
	{you: "Helen, listen to me"},
	{you: "I love you too"},
	{you: "I love you so much it hurts"},
	{her: "Jack..."},
	{you: "You are so beautiful"},
	{you: "Inside and outside"},
	{you: "I just want to be with you"},
	{her: "..."},
	{her: "...", img: "girlsmile"},
	{her: "Jack..."},
	{her: "I'm so happy...", func:function(){thoughts = [];}},
	{thoughts: "kiss"}
    ],
    kiss: [
	{you: "Helen, I want to kiss you"},
	{her:"...", img:"girlscared"},
	{wait: 2000, func: function(){thoughts = [];thoughtstate.grabbed = -1;}},
	{her: "I want to kiss you too",img:"girlsmile"},
	{her: "Do you think we are ready?",img:"girlsmile"},
	{you: "I don't know"},
	{you: "I think there is only one way to find out"},
	{won:true}
    ],
    lose: [
	{wait: 1000, img:"girldis"},
	{her: "Jack.", func:function(){game.sound.happy.pause();}},
	{you: "Yes?"},
	{her: "..."},
	{her: "What is happening to you?", func:function(){game.sound.sad.play();}},
	{her: "You are so different, out of the blue."},
	{her: "So..."},
	{wait: 1000},
	{her: "Creepy"},
	{you: "Helen, I..."},
	{her: "I think it was a mistake to come over here."},{ thoughts: "fuckedup1"},
	{her: "I better leave now"},{ thoughts: "fuckedup2", func:function() {for( var i=0; i<thoughts.length; i++) { thoughts[i].shake = 2; }}},
	{you: "No, Helen, wait!"},
	{you: "I have so many things to say to you!"},{ thoughts: "fuckedup3", func:function() {for( var i=0; i<thoughts.length; i++) { thoughts[i].shake = 4; }}},
	{her: "I'm sorry"},{ thoughts: "fuckedup4", func:function() {for( var i=0; i<thoughts.length; i++) { thoughts[i].shake = 6; }}},
	{her: "I think it is better for me to leave now."},{ thoughts: "fuckedup5", func:function() {for( var i=0; i<thoughts.length; i++) { thoughts[i].shake = 8; }}},
	{her: "I... Um."},
	{her: "Will need some time to forget"},{ thoughts: "fuckedup6", func:function() {for( var i=0; i<thoughts.length; i++) { thoughts[i].shake = 10; }}},
	{you: "Helen..."},
	{her: "Some time to forget you"},
	{wait: 1000},
	{her: "I'm sorry"},
	{lost:true}
    ]
};
